'From OLPC2.0 of ''24 October 2006'' [latest update: #1355] on 2 June 2007 at 11:31:25 am'!
ClipboardInterpreter subclass: #UnicodeClipboardInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnicodeEnvironment'!
LanguageEnvironment subclass: #UnicodeEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnicodeEnvironment'!
KeyboardInputInterpreter subclass: #UnicodeInputInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnicodeEnvironment'!

!UnicodeInputInterpreter commentStamp: '<historical>' prior: 0!
No conversion is being made on the keyboard input.
Unicode keycodes are expected as the sixth data member of the event buffer, as opposed in
nextCharFrom: sensor firstEvt: evtBuf
!

TextConverter subclass: #UnicodeTextConverter
	instanceVariableNames: ''
	classVariableNames: 'FromTable'
	poolDictionaries: ''
	category: 'UnicodeEnvironment'!

!UnicodeClipboardInterpreter methodsFor: 'as yet unclassified' stamp: 'C.P. 5/31/2007 15:25'!
fromSystemClipboard: aString

	^ aString convertFromWithConverter: (UTF8TextConverter new).
! !

!UnicodeClipboardInterpreter methodsFor: 'as yet unclassified' stamp: 'C.P. 5/30/2007 18:00'!
toSystemClipboard: aString

	| result utfString |
"
	aString isOctetString ifTrue: [^ aString asOctetString]."

	utfString := aString convertToWithConverter: (UTF8TextConverter new).
	result _ WriteStream on: (String new: utfString size).
	utfString do: [:each | result nextPut: each].
	^ result contents.
! !


!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
clipboardInterpreterClass

	^ UnicodeClipboardInterpreter.
! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
defaultEncodingName
	| platformName osVersion |
	platformName := SmalltalkImage current platformName.
	osVersion := SmalltalkImage current  getSystemAttribute: 1002.
	(platformName = 'Win32' and: [osVersion = 'CE']) ifTrue: [^'utf-8' copy].
	(#('Win32') includes: platformName) 
		ifTrue: [^'unicode' copy].
	(#('unix') includes: platformName) ifTrue: [^'unicode' copy].
	^'mac-roman'! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
fileNameConverterClass

	^ UnicodeTextConverter.

! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
inputInterpreterClass

	^ UnicodeInputInterpreter.
! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
leadingChar

	^ 0.
! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:31'!
supportedLanguages
	"Return the languages that this class supports. 
	Any translations for those languages will use this class as their environment."
	
	^ self subclassResponsibility.! !

!UnicodeEnvironment class methodsFor: 'subclass responsibilities' stamp: 'C.P. 5/31/2007 16:30'!
systemConverterClass

	^ UnicodeTextConverter.
! !


!UnicodeInputInterpreter methodsFor: 'as yet unclassified' stamp: 'C.P. 5/22/2007 11:06'!
nextCharFrom: sensor firstEvt: evtBuf

	| keyValue |
" Unicode charCode expected as the sixth data member !! "
	keyValue := evtBuf sixth.
	Transcript show: evtBuf asString; cr.
	^ keyValue asCharacter.
! !


!UnicodeTextConverter methodsFor: 'conversion' stamp: 'C.P. 5/20/2007 17:38'!
nextFromStream: aStream

	| character1 |
	aStream isBinary ifTrue: [^ aStream basicNext].
	character1 _ aStream basicNext.
	character1 isNil ifTrue: [^ nil].
	^ character1.
! !

!UnicodeTextConverter methodsFor: 'conversion' stamp: 'C.P. 5/20/2007 17:37'!
nextPut: aCharacter toStream: aStream

	aStream isBinary ifTrue: [^aCharacter storeBinaryOn: aStream].
	aStream basicNextPut: aCharacter.

! !


!UnicodeTextConverter class methodsFor: 'utilities' stamp: 'C.P. 5/20/2007 17:28'!
encodingNames 

	^ #('unicode') copy
! !

